# Description: Makefile fragment for GASNet_tools, GASNET_#THREAD_MODEL# mode
# #AUTOGEN#
# other/gasnet_tools-fragment.mak.  Generated from gasnet_tools-fragment.mak.in by configure.
# $Revision: 1.1 $
# Copyright 2011, Dan Bonachea <bonachea@cs.berkeley.edu>
# Terms of use are as specified in license.txt

# ----------------------------------------------------------------------
# Usage instructions:
#
# Clients should include this file in their Makefile, using: (no leading '#')
#     include ###INSTALL_PREFIX###/include/gasnet_tools-#thread_model#.mak  
# or alternatively, just:
#     include gasnet_tools-#thread_model#.mak  
# and use a -I###INSTALL_PREFIX###/include
# command-line option when invoking make
#
# Then in the Makefile, use a compile line something like this:
#  $(GASNETTOOLS_CC) $(GASNETTOOLS_CPPFLAGS) $(GASNETTOOLS_CFLAGS) -c myfile.c
#
# and a link line something like this:
#  $(GASNETTOOLS_LD) $(GASNETTOOLS_LDFLAGS) -o myfile myfile.o $(GASNETTOOLS_LIBS)
# ----------------------------------------------------------------------

GASNETTOOLS_INCLUDES =  -I###INSTALL_PREFIX###/include
GASNETTOOLS_INCLUDES =  -I/home/bradc/chapel-1.6.1.1/third-party/gasnet/GASNet-1.18.2 -I/home/bradc/chapel-1.6.1.1/third-party/gasnet/GASNet-1.18.2/other -I/home/bradc/chapel-1.6.1.1/third-party/gasnet/build/linux64-gnu/seg-everything/nodbg ###NOINSTALL###

GASNETTOOLS_LIBDIR = ###INSTALL_PREFIX###/lib
GASNETTOOLS_LIBDIR = /home/bradc/chapel-1.6.1.1/third-party/gasnet/build/linux64-gnu/seg-everything/nodbg  ###NOINSTALL###

GASNETTOOLS_DEBUGFLAGS = -DNDEBUG

GASNETTOOLS_THREADFLAGS_PAR = -DGASNETT_THREAD_SAFE -D_REENTRANT -D_GNU_SOURCE
GASNETTOOLS_THREADFLAGS_SEQ =
GASNETTOOLS_THREADFLAGS = $(GASNETTOOLS_THREADFLAGS_#THREAD_MODEL#)

GASNETTOOLS_THREADLIBS_PAR = -lpthread 
GASNETTOOLS_THREADLIBS_SEQ = 
GASNETTOOLS_THREADLIBS = $(GASNETTOOLS_THREADLIBS_#THREAD_MODEL#)

GASNETTOOLS_TOOLLIB_NAME = gasnet_tools-#thread_model#

GASNETTOOLS_CC = /usr/lib64/ccache/gcc 
GASNETTOOLS_CPPFLAGS = $(GASNETTOOLS_DEBUGFLAGS) $(GASNETTOOLS_THREADFLAGS)  $(GASNETTOOLS_INCLUDES) $(MANUAL_CPPFLAGS)
GASNETTOOLS_CFLAGS = -O3 --param max-inline-insns-single=35000 --param inline-unit-growth=10000 --param large-function-growth=200000 -Winline  $(KEEPTMP_CFLAGS) $(MANUAL_CFLAGS)
GASNETTOOLS_LD = /usr/lib64/ccache/gcc 
GASNETTOOLS_LDFLAGS = -O3 --param max-inline-insns-single=35000 --param inline-unit-growth=10000 --param large-function-growth=200000 -Winline  -L$(GASNETTOOLS_LIBDIR) $(MANUAL_LDFLAGS)
GASNETTOOLS_LIBS = -l$(GASNETTOOLS_TOOLLIB_NAME) $(GASNETTOOLS_THREADLIBS)  -lm $(MANUAL_LIBS)
GASNETTOOLS_CXX = /usr/lib64/ccache/g++ 
GASNETTOOLS_CXXFLAGS = -O2  -g3 -Wall -Wno-unused -Wno-address -Wpointer-arith -Wwrite-strings -Wmissing-format-attribute $(MANUAL_CXXFLAGS)

